% SACAFOT extract the frames in the positions 'v' from 'SEC'
% frames are of size m*n
% USE: fotog=sacafot(SEC,m,n,v);

function fotogramas=sacafot(sec,fil,col,N)

s=size(sec);
fotogramas=zeros(fil,length(N)*col);
for fot=1:length(N)
    nfot=N(fot);
    fotogramas(:,col*(fot-1)+1:col*fot)=sec(:,col*(nfot-1)+1:col*nfot);
end

