
function [IAFet,CSFet]=iafet(fe,facfrec,ft,C,nolin,estab)

if length(nolin)==1
   nolin=[nolin nolin];
end

nolini=nolin;
nolin=nolini(1);

if ((nolini(1)==0)&(nolini(2)==1))
   nolin=1;
end

   fe=fe+0.00001*(fe==0);

   if estab==1
      if ft>0.3
         fec=facfrec*fe;
         CSFet=(250/1896.4)*(ft.*fec*4*pi^2).*(6.1+7.3*abs(log10(ft./(3*fec))).^3).*exp(-(4*pi*(ft+2*fec)/45.9));
         CSFet=0.000001*(CSFet==0)+CSFet;
         c1=(1./CSFet)>1;
         c2=(1./CSFet)<1;
         CSFet=CSFet.*c2+c1;
         Cu=1./CSFet;
         Cu=Cu*ones(1,length(C));

      else
         fm=3;
         p=1;
         cum=0.004;
         fe=facfrec*fe;
         CSFet=((fe/fm).^p).*exp(-(fe/fm));
         CSFet=CSFet/maxi(CSFet);
         CSFet=(1/cum)*CSFet;
         CSFet=0.000001*(CSFet==0)+CSFet;
         c1=(1./CSFet)>1;
         c2=(1./CSFet)<1;
         CSFet=CSFet.*c2+c1;
         Cu=1./CSFet;
         Cu=Cu*ones(1,length(C));
      end
      if nolin==1
         lonf=length(fe);
         fe=fe*ones(1,length(C));
         k=(-0.079389*log10(fe)+0.322725);
         n=0.84*((fe.^1.7)./(0.7.^1.7+fe.^1.7));
         C=ones(lonf,1)*C;
         IAFet=1./(Cu+(((k.*(C.^n))-Cu).*(C./((Cu./k).^(1./n)+C))));
      else
         IAFet=1./Cu;
      end
   else
      fec=facfrec*fe;
      CSFet=(250/1896.4)*((ft+0.1*fec).*fec*4*pi^2).*(6.1+7.3*abs(log10((ft+0.1*fec)./(3*fec))).^3).*exp(-(4*pi*((ft+0.1*fec)+2*fec)/45.9));
      CSFet=0.000001*(CSFet==0)+CSFet;
      c1=(1./CSFet)>1;
      c2=(1./CSFet)<1;
      CSFet=CSFet.*c2+c1;
      Cu=1./CSFet;
      Cu=Cu*ones(1,length(C));

      if nolin==1
         fe=facfrec*fe;
         lonf=length(fe);
         fe=fe*ones(1,length(C));
         k=(-0.079389*log10(fe)+0.322725);
         n=0.84*((fe.^1.7)./(0.7.^1.7+fe.^1.7));
         C=ones(lonf,1)*C;
         IAFet=1./(Cu+(((k.*(C.^n))-Cu).*(C./((Cu./k).^(1./n)+C))));
      else
         IAFet=1./Cu;
      end
   end

if ((nolini(1)==0)&(nolini(2)==1))
   s=size(IAFet);
   iafet=sum(IAFet')';
   IAFet=iafet*ones(1,s(2));
end
