
function H = kernel2d(tam,varianza)

fN=32;

lcuan=tam;

fx = linspace(0,fN,tam);
fy = fx;

Fx = repmat(fx,tam,1);
Fy = repmat(fy',1,tam);

F=sqrt(Fx.^2+Fy.^2);

fx=zigzag(Fx);
fy=zigzag(Fy);
f=zigzag(F);

ind=find(f==0);

H=zeros(lcuan^2,lcuan^2);

cont = 1;
for i=1:lcuan
   for j=1:lcuan
      hh=exp(-((Fx-fx(cont)).^2+(Fy-fy(cont)).^2)/varianza);
      H(cont,:)=(zigzag(hh))';
      cont = cont + 1;
   end
end

H = H(2:end,2:end);

H = H./ repmat(sum(H,2),1,lcuan^2-1);

