%
% The string returned by rle2 always ends with 0, so that it is
% to find the last 0 of the string and take the following values ​​(which will
% be the number of consecutive zeros to replace each 0 appears
% previously).
%
% When all have been replaced it takes the last zero again,
% removing the previously processed block and so on to the beginning.
%
% The blocks processed rle2 lack the DC component, it
% will be get from the DPCM errors.
%

function [ristra_original] = inv_rle(ristra)
ristra_original = zeros(256,255);
pos_ceros = find(ristra == 0);
tamanyo = length(ristra);
for i = 256:-1:1
      if(i == 10)
          a = 1;
      end
    bloque = [];

    pos_ult_cero = pos_ceros(end);

    num_ceros = ristra(pos_ult_cero + 1:tamanyo);

    ristra = ristra(1:pos_ult_cero);

    tamanyo = length(ristra);

    for j = 1:length(num_ceros)

        pos_ceros = pos_ceros(1:end-1);

        bloque = [zeros(1,num_ceros(end)) bloque];

        if(length(num_ceros) > 1)
            num_ceros = num_ceros(1:end-1);
        end

        ristra = ristra(1:tamanyo-1);

        tamanyo = length(ristra);

        if(length(bloque) == 255)
            break;
        end

        if(tamanyo == 0)
            break;
        end

        while(ristra(tamanyo) ~= 0 & length(bloque) < 255)
            bloque = [ristra(tamanyo) bloque];
            ristra = ristra(1:tamanyo-1);
            tamanyo = length(ristra);
            if(tamanyo == 0)
                break;
            end
        end
    end

    ristra_original(i,:) = bloque;
end
