% Given a .zip file it gets ristra/sequence and obtains the decoded image

function [Results] = jpeg91_c_decoder(normaliz,To,dUmax,dVmax,directorio,fichero,niveles,bitmax)
you_are_here=pwd;

if(nargin < 8 && niveles == 1)
    bitmax = 1;
end

if niveles==0
    k = [];
    for canal=1:3
        [ciaf1D,N,iaf] = vqperc_crom_lin_2(16,1,2,0,0,uCP(canal),bitmax,32,canal,0);
        k=[k; N(1:16)];
    end
    M = maxi(k);
    k = k/M;
else
    opcion = 1;
    Fc = 0;
    Pesos = [1 1 1];
    k = deal_levels(16,64,opcion,Fc,Pesos);
end

cd(directorio)
unzip([fichero '.zip']);
ristra = read_code([fichero '.bin']);

delete([fichero '.bin']);
TheCode=zeros(256,255,3);

posicion=length(ristra);
queda_ristra=ristra;
for cap=3:-1:1
    if cap==1
        for i=256:-1:1
            queda_ristra=ristra(1:posicion);
            ceros=find(queda_ristra==0);
            pos_cero=ceros(end);
            ceros_bloque=queda_ristra(pos_cero+1:end);
            queda_ristra=queda_ristra(1:pos_cero);
            posicion=pos_cero;
            bloque=[];
            long_bloque=0;
            while long_bloque<255

                dato=queda_ristra(posicion);
                queda_ristra=queda_ristra(1:end-1);
                posicion=posicion-1;
                if dato==0
                    bloque=[zeros(1,ceros_bloque(end)) bloque];
                    ceros_bloque=ceros_bloque(1:end-1);
                    long_bloque=length(bloque);
                else
                    bloque=[dato bloque];
                    long_bloque=length(bloque);
                end
            end
            TheCode(i,:,cap)=bloque;
        end
    else
        for i=256:-1:1
            queda_ristra=ristra(1:posicion);
            ceros=find(queda_ristra==0);
            pos_cero=ceros(end);
            ceros_bloque=queda_ristra(pos_cero+1:end);
            queda_ristra=queda_ristra(1:pos_cero);
            posicion=pos_cero;
            bloque=[];
            long_bloque=0;
            while long_bloque<63

                dato=queda_ristra(posicion);
                queda_ristra=queda_ristra(1:end-1);
                posicion=posicion-1;
                if dato==0
                    bloque=[zeros(1,ceros_bloque(end)) bloque];
                    ceros_bloque=ceros_bloque(1:end-1);
                    long_bloque=length(bloque);
                else
                    bloque=[dato bloque];
                    long_bloque=length(bloque);
                end
            end
            blo=zeros(16,16);
            bloo=[0 bloque];
            bloo=dezigzag(bloo);
            blo(1:8,1:8)=bloo;
            bloque=zigzag(blo);
            bloque=bloque(2:end);
            TheCode(i,:,cap)=bloque;
        end
    end
end

bits=queda_ristra(end-2:end);

NumNiv=2.^bits;
MM=0.8;
TheRealCode=TheCode;
for cap=1:3
    TheRealCode(:,:,cap)=TheCode(:,:,cap)*MM/NumNiv(cap);
end

queda_ristra=queda_ristra(1:end-3);
QE=queda_ristra(7:end);
QQEE(:,:,1)=reshape(QE(1:256),16,16);
QQEE(:,:,2)=reshape(QE(257:512),16,16);
QQEE(:,:,3)=reshape(QE(513:end),16,16);

extr_err=zeros(2,3);
extr_err(:,1)=queda_ristra(1:2)';
extr_err(:,2)=queda_ristra(3:4)';
extr_err(:,3)=queda_ristra(5:6)';

N=round(0.9*[40 10 10]);
for i=1:3
    qe(:,:,i)=(extr_err(2,i)-extr_err(1,i))*QQEE(:,:,i)/(N(i)-1)+extr_err(1,i);
end

for i=1:3
    Lmq(:,:,i)=iimdpcm(qe(:,:,i),1,To(i));
end

Li = 256;
Lb = 16;

aa = zeros(Lb);
[r,alfa2d(:,:,1)]=respue_lin(aa,k,1);
[r,alfa2d(:,:,2)]=respue_lin(aa,k,2);
[r,alfa2d(:,:,3)]=respue_lin(aa,k,3);
fprintf('Recovering the image:\n');
fprintf('  Inverting from linear r to dct\n');

for capa = 1:3
    for bloque = 1:256
        aa = TheRealCode(bloque,:,capa);
        signosr(bloque,:,capa) = getsign(aa,Lb);
    end
end
for cap=1:3
    z = 1;
    for i=1:Lb:(Li-1)
        for j=1:Lb:(Li-1)

            r_recon = abs(TheRealCode(z,:,cap))';

            r_recon = [0; r_recon];

            ac = r_recon./alfa2d(:,:,cap);

            ac1 = obtainsign(ac(2:end),signosr(:,:,cap),Lb,z);
            ac1 = [0;ac1];
            ac1 = dezigzag(ac1);

            dctc1(i:(i+(Lb-1)),j:(j+(Lb-1)),cap) = ac1;

            z = z+1;
        end
    end
end
fprintf('  Inverting from dct-contrast to spatial domain\n');

dctc1i = icontras3(dctc1,Lmq,4,normaliz,To,dUmax,dVmax);
for cap = 1:3
    ImRyuv(:,:,cap)=real(idct2r(dctc1i(:,:,cap),4));
end
ImR = my_yuv2rgb(ImRyuv);

Results = uint8(ImR);
cd(you_are_here)
