% 'Respuestafourier' computes the non-linear response when using Fourier as
% lineal transformation
%
% USE: r = responsefourier(bloque,lcuan,H,k1,k2);

function r=responsefourier(bloque,lcuan,H,k1,k2);

M=lcuan;

ang = linspace(0,pi/2,5);
v = [reverse(cos(ang)) ones(1,M-2*5) cos(ang)];
pesos = v'*v;

observado2 = bloque.*pesos + (1-pesos).*mean(mean(bloque));

cub = fft2(observado2);cub = 2*cub/cub(1,1);cub = abs(cub);

cub(1,1)=0;

cub=fftshift(cub);

M=size(cub,1);

cublin=zigzag(cub);

cubcub=cublin.^2;

num = k1.*cubcub;
den = k2 + H*cubcub;

r=num./den;

r=dezigzag(r);

