% The restoration methods should call seleccion_lambda being the last
% parameter indicating the function to be called to get the lambda
%  1: pasando_norma_ruido
%  2: max_incr_pend_Lcurva
%

function valorlambda = seleccion_lambda(x,y,lambdas,normaruido,metodo);

val = 0;

switch metodo
    case 1
        val = feval(@pasando_norma_ruido,x,lambdas,normaruido);
    case 2
        val = feval(@max_incr_pend_Lcurva,x,y,lambdas);
    otherwise
         disp('Este criterio para el parametro de regularizacion no existe!');
end

valorlambda = val;

