
figure;

clc;
echo off;

disp('Loading image');

load barbara256;
imshow(Im/255);
title('Original image');

disp('Degrading image (almost denoising)');

fc = 24;
Val_min = 0.001;

lim_frec = [0 3];

vari = 400;

[Id,PSF,H,noise,Blurred]=degrade2(Im,fc,Val_min,lim_frec,vari);
figure;
imshow(Id/255);
title(['Degraded image (f_c = ' num2str(fc) ',\sigma^2 = ' num2str(vari) ')']);

disp('Press any key...');
pause;

disp('SENSITIVITY TO LAMBDA');

Nlambdas = 1;
lambdas = 1;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);

imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 2;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);

imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 4;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);

imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 6;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);

imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 10;

disp(['Restoring image using PERCEPTUAL (' num2str(Nlambdas) ' values of lambda)']);

imrper=restaura2(Id,'PER',PSF,lambdas);

figure;
imshow(imrper/255);
title(['Perceptual, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 1;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);

imrar12=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 2;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);

imrar12=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 4;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);

imrar12=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 6;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);

imrar8=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);

Nlambdas = 1;
lambdas = 10;

disp(['Restoring image using AR12 (' num2str(Nlambdas) ' values of lambda)']);

imrar8=restaura2(Id,'AR12',PSF,lambdas);

figure;
imshow(imrar12/255);
title(['AR12, \lambda=' num2str(lambdas)]);

