% This script performs denoising using th emethod in:
% "Bayesian wavelet-based image estimation using noninformative priors"
% M.A Figueiredo and R.D Nowak
%
% USO: [IMM]=figueiredo(Im2,Var)
% Im2 noisy image
% Var noise variance

function [IMM]=figueiredo(Im2,Var)

orientaciones=cell(3,1);

orientaciones{1}='H';
orientaciones{2}='V';
orientaciones{3}='D';
pyr=[];
pp=[];
for subb=1:4
    for ori=1:3
        orientacion=orientaciones{ori};

        switch lower(orientacion)
            case 'h'
                sub=1;
            case 'v'
                sub=2;
            case 'd'
                sub=3;
        end

        [histograma,valores,subbanda,subbandacrop]=marginal_2(Im2,subb,orientacion,256);
        [x_est]=estimation_figueiredo(subbanda,Var);
        pyr=[pyr x_est'];

    end
end
[QQ,ind]=buildwpyr(Im2,4);
pyr=[pyr QQ(end-255:end)'];
IMM=reconwpyr(pyr',ind);
