
function [signos_dct] = epifanio03_encoder_v2(Im,uCP,directorio,fichero)
M = 10;
trayfich = 'estarereB';

N = size(Im,1);

load(trayfich);

Ncuan = 4;

Li = N;
Lb = N / 2^Ncuan;

dcti = dct2r(Im,Ncuan);

[dctc,Lm] = contrast_2(dcti,Ncuan,[1 0]);

W = 1;

val_r = 100;

e = imdpcm(Lm,W,val_r);

Nc = round(0.9 * 40);
me = mini(e);
Me = maxi(e);
extr_err = [me Me];
QE = round((Nc -1) * (e - me) / (Me - me));

dctc = abs(dctc);
signos = sign(dcti);
signos(signos == 0) = 1;

L = V2'*grad;
invgrad = inv(grad);
codigones = zeros(Li,Li);
codigazo = [];
bloquecito = 1;
for i = 1:Lb:Li
    for j = 1:Lb:Li

        bloque = dctc(i:i+Lb-1,j:j+Lb-1);

        bloque_z = zigzag(bloque);

        bloque_z = L * (bloque_z) + consta;

        codigo = round(2^uCP .* bloque_z ./ M);

        codigo(1) = 0;

        signo_b = signos(i:i+Lb-1,j:j+Lb-1);
        signo_b_z = zigzag(signo_b);

        codigonint = codigo;
        codigones(bloquecito,:) = codigonint;

        codigonint = codigonint(2:end);
        [valores, ceros] = rle2(codigonint);

        codigazo = [codigazo valores ceros];
        bloquecito = bloquecito + 1;
        signos_dct(bloquecito-1,:) = signo_b_z';
    end
end

        signos_rf = sign(codigones);
        signos_rf(signos_rf == 0) = 1;
        mis_signos = signos_rf;

ristra = [extr_err(:)' round(QE(:))' uCP round(codigazo)];

cd(directorio);
save_code_epifanio03(ristra,[fichero '.bin']);
zip(fichero,[fichero '.bin']);

delete([fichero '.bin']);

