
function [Results]=svr_nl_c_decoder_cs(normaliz,To,dUmax,dVmax,K,exponentes,tipo_alfa,directorio,fichero)

you_are_here=pwd;

cd(directorio)
unzip([fichero '.zip']);
ristra = read_code([fichero '.bin']);

delete([fichero '.bin']);

TheCode=zeros(256,255,3);

posicion=length(ristra);
queda_ristra=ristra;
for cap=3:-1:1

    if cap==1
        for i=256:-1:1

            queda_ristra=ristra(1:posicion);
            ceros=find(queda_ristra==0);
            pos_cero=ceros(end);
            ceros_bloque=queda_ristra(pos_cero+1:end);
            queda_ristra=queda_ristra(1:pos_cero);
            posicion=pos_cero;

            bloque=[];

            long_bloque=0;

            while long_bloque<255

                dato=queda_ristra(posicion);
                queda_ristra=queda_ristra(1:end-1);
                posicion=posicion-1;
                if dato==0
                    bloque=[zeros(1,ceros_bloque(end)) bloque];
                    ceros_bloque=ceros_bloque(1:end-1);
                    long_bloque=length(bloque);
                else
                    bloque=[dato bloque];
                    long_bloque=length(bloque);
                end

            end
            TheCode(i,:,cap)=bloque;
        end
    else
        for i=256:-1:1

            queda_ristra=ristra(1:posicion);
            ceros=find(queda_ristra==0);
            pos_cero=ceros(end);
            ceros_bloque=queda_ristra(pos_cero+1:end);
            queda_ristra=queda_ristra(1:pos_cero);
            posicion=pos_cero;

            bloque=[];

            long_bloque=0;

            while long_bloque<63

                dato=queda_ristra(posicion);
                queda_ristra=queda_ristra(1:end-1);
                posicion=posicion-1;
                if dato==0
                    bloque=[zeros(1,ceros_bloque(end)) bloque];
                    ceros_bloque=ceros_bloque(1:end-1);
                    long_bloque=length(bloque);
                else
                    bloque=[dato bloque];
                    long_bloque=length(bloque);
                end

            end
            blo=zeros(16,16);
            bloo=[0 bloque];
            bloo=dezigzag(bloo);
            blo(1:8,1:8)=bloo;
            bloque=zigzag(blo);
            bloque=bloque(2:end);
            TheCode(i,:,cap)=bloque;
        end
    end
end

bits=queda_ristra(end-2:end);

NumNiv=2.^bits;
MM=0.8;

TheRealCode=TheCode;
for cap=1:3
    TheRealCode(:,:,cap)=TheCode(:,:,cap)*MM/NumNiv(cap);
end

queda_ristra=queda_ristra(1:end-3);
QE=queda_ristra(7:end);
QQEE(:,:,1)=reshape(QE(1:256),16,16);
QQEE(:,:,2)=reshape(QE(257:512),16,16);
QQEE(:,:,3)=reshape(QE(513:end),16,16);

extr_err=zeros(2,3);
extr_err(:,1)=queda_ristra(1:2)';
extr_err(:,2)=queda_ristra(3:4)';
extr_err(:,3)=queda_ristra(5:6)';

N=round(0.9*[40 10 10]);
for i=1:3
    qe(:,:,i)=(extr_err(2,i)-extr_err(1,i))*QQEE(:,:,i)/(N(i)-1)+extr_err(1,i);
end

for i=1:3
    Lmq(:,:,i)=iimdpcm(qe(:,:,i),1,To(i));
end

Li = 256;
Lb = 16;

cero = 1;

[h,alpha,beta,gamm]=constrains_respY(exponentes(1),cero,tipo_alfa);
[hU,alphaU,betaU,gammU]=constrains_respU(exponentes(2),cero);
[hV,alphaV,betaV,gammV]=constrains_respV(exponentes(3),cero);

aa = zeros(Lb);
[h_a,r,GR,alfa2d,beta2d]=respue5(aa,alpha,beta,gamm,h,0);
[h_a,r,GR,alfa2dU,beta2dU]=respue5(aa,alphaU,betaU,gammU,hU,0);
[h_a,r,GR,alfa2dV,beta2dV]=respue5(aa,alphaV,betaV,gammV,hV,0);

fprintf('Recovering the image:\n');
fprintf('  Inverting from r to dct\n');

trc(:,:,1) = TheRealCode(:,:,1)';
trc(:,:,2) = TheRealCode(:,:,2)';
trc(:,:,3) = TheRealCode(:,:,3)';
TheRealCode = trc;

Identidad = eye(size(h));

for cap=1:3
    fprintf('    Channel %d: ',cap);

    if cap==1
        Db=diag(beta2d);
    elseif cap==2
        Db=diag(beta2dU);
        alfa2d=alfa2dU;
        gamm=gammU;
        h=hU;
    else
        Db=diag(beta2dV);
        alfa2d=alfa2dV;
        gamm=gammV;
        h=hV;
    end

    z = 1;

    for i=1:Lb:(Li-1)
        fprintf('.');

        for j=1:Lb:(Li-1)

            r_recon=K*TheRealCode(:,z,cap);

            signosr = r_recon<0;

            r_recon = [0; abs(r_recon)];

            Dr=diag(r_recon);

            ac = ((inv(Identidad-Dr*h)*Db*r_recon).^(1/gamm))./alfa2d;

            ac_c = ac(2:end);

            acs = ac_c.*(signosr==0) - ac_c.*(signosr>0);

            acs = [0;acs];

            acs=dezigzag(acs);

            dctc1(i:(i+(Lb-1)),j:(j+(Lb-1)),cap)=acs;

            z=z+1;
        end
    end
    fprintf('\n');
end
fprintf('\n');

fprintf('  Inverting from dct to spatial domain\n');

Ncuan = 4;

dctc1i=icontras3(dctc1,Lmq,Ncuan,normaliz,To,dUmax,dVmax);

for cap=1:3
    ImRyuv(:,:,cap)=real(idct2r(dctc1i(:,:,cap),Ncuan));
end

ImR=my_yuv2rgb(ImRyuv);

Results = uint8(ImR);

cd(you_are_here)
