% SIGM1D applies the formula:
%
%                         1
%     s(x,xo,s) = -------------------
%                  1 + exp((x-xo)/s)
%
% USE: y = sigm1d(x,xo,s);

function y=sigm1d(x,x0,s);

y=1./(1+exp((x-x0)/s));
