%
% KeCoDe: Kernel-based image Coding and Denoising Toolbox
%
% KeCoDe demos.
%   KeCoDe_coder_tools_demo_achrom   - Compares 6 achromatic image coders.
%   KeCoDe_coder_tools_demo_color    - Compares 2 color image coders.
%   KeCoDe_image_degradation_demo    - Shows a range of image degradations.
%   KeCoDe_image_denoising_demo      - Compares 4 denosing techniques
%   KeCoDe_image_restoration_demo    - Compares 6 restoration techniques
%
% Coding achromatic images.
%   KeCoDe_encoder_achrom  - Generates compressed file from achromatic image.
%   KeCoDe_decoder_achrom  - Generates achromatic image from compressed file.
%
% Coding color images.
%   KeCoDe_encoder_color  - Generates compressed file from color image.
%   KeCoDe_decoder_color  - Generates color image from compressed file.
%
% Image degradation.
%   KeCoDe_degradation    - Applies controlled degradation to images.
%
% Image denoising.
%   KeCoDe_denoising      - Wavelet and Kernel based denoising techniques.
%
% Image restoration.
%   KeCoDe_restoration    - Local regularization restoration techniques.
%
%   Copyright 1995-2011
%   Juan Gutierrez, Valero Laparra, Gustavo Camps-Valls and Jesus Malo
%   $ Date: 2011/25/11 23:22:40 $
