
function [PSD,operador,coef_ar] = fit_it_block_ar8(observado)

M = size(observado,1);

Y=[];
rhs=[];

bloque = observado;

for jj=2:M-1
   for kk=2:M-1
      Y=[Y; bloque(jj+1,kk+1:-1:kk-1) bloque(jj,kk+1) bloque(jj,kk-1) bloque(jj-1,kk+1:-1:kk-1)];
      rhs =[rhs;bloque(jj,kk)];
   end
end

coef_ar = Y\rhs;

ptos=M;

w=linspace(-pi,pi,ptos);

z1=exp(sqrt(-1)*w);
z2=exp(sqrt(-1)*w);

F = zeros(ptos);
espectro = F;

for jj=1:ptos
   for kk=1:ptos
      v1 = coef_ar(1)*z1(jj)^1*z2(kk)^1;
      v2 = coef_ar(2)*z1(jj)^1*z2(kk)^0;
      v3 = coef_ar(3)*z1(jj)^1*z2(kk)^(-1);
      v4 = coef_ar(4)*z1(jj)^0*z2(kk)^1;
      v5 = coef_ar(5)*z1(jj)^0*z2(kk)^(-1);
      v6 = coef_ar(6)*z1(jj)^(-1)*z2(kk)^(1);
      v7 = coef_ar(7)*z1(jj)^(-1)*z2(kk)^(0);
      v8 = coef_ar(8)*z1(jj)^(-1)*z2(kk)^(-1);

      val = 1 - (v1 + v2 + v3 + v4 + v5 + v6 + v7 + v8);
      F(jj,kk) = val;
      PSD(jj,kk) = 1 / abs(val)^2;
   end
end

operador = F;

