% Numerator of the bayesian operator using
% quadratic loss function and exponential prior distribution (heavy tail)

function val = blsnum(c,y,s,p,sigman)

val = c.*exp(-((((y-c).^2)/(2*sigman^2)) + abs(c/s).^p) );
