% Likelihood value for different observations and values of 'P' and 'S'

function l = likelihooddegradedaB(param,datos,vari)
cadacuantos = 1;
muestra = datos(1:cadacuantos:end);
N = length(muestra);

s=abs(param(1));
p=abs(param(2));

integrales = zeros(size(muestra));
xx=[min(muestra)-10:1:10+max(muestra)];
Q=(abs(max(xx))+abs(min(xx)))/length(xx);
for i=1:length(muestra)
     AA=blsdenom(xx,muestra(i),s,p,sqrt(vari));
    integrales(i) = sum(Q.*AA);
end
l = N*log(sqrt(vari)*sqrt(2*pi)*2*s/p*gamma(1/p))-sum(log(integrales));
